#include<iostream>
#include<queue>
#include<algorithm>
#define MAX 1000000000

using namespace std;

    int G[520][520];
    int used[520],used2[520];
    int prev[520];
    
    int n,k;
    int ans,fl;
    
    queue<int> q;
    //soldier 1+k+1...n
    //general 1+1...k
    //source 1
    //sink 2+k+n
bool BFS()
{
    int i,u;
    
	while(q.size()>0)q.pop();
	
    q.push(2+k+n);
    used2[2+k+n]=1;
    
	while(q.size()>0)
    {
	  u=q.front();
	  q.pop();
	  
	  if(u==(2+k+n))
	  {
	    for(i=1+k+1;i<=1+k+n;i++)
	    if(G[i][u] && !used2[i])
	    {
		 used2[i]=used2[u]+1;
		 q.push(i);
		}
	  }
	  else
	  if(u>=2 && u<=1+k)
	  {
	    if(G[1][u]){used2[1]=used2[u]+1;return true;}
	    for(i=1+k+1;i<=1+k+n;i++)
	    if(G[i][u] && !used2[i])
	    {
		 used2[i]=used2[u]+1;
		 q.push(i);
		}
	  }
	  else
	  {
	    for(i=2;i<=1+k;i++)
	    if(G[i][u] && !used2[i])
		{
		 used2[i]=used2[u]+1;
		 q.push(i);
		}
	  }
	}
return false;
}
void DFS(int u)
{
   used[u]=1;
   int i;
   
   //printf("%d\n",u);
   if(fl)return;
   if(u==(2+k+n)){fl=1;return;}
   
      if(u>=2+k && u<=1+k+n)
	  {
		if(G[u][2+k+n] && !fl && used2[2+k+n]==used2[u]-1){prev[2+k+n]=u;DFS(2+k+n);}
	    for(i=2;i<=1+k;i++)
	    if(G[u][i] && !used[i] && used2[i]==used2[u]-1 && !fl){prev[i]=u;DFS(i);}
	  }
	  else
	  if(u>=2 && u<=1+k)
	  {
	    for(i=1+k+1;i<=1+k+n;i++)
	    if(G[u][i] && !used[i] && used2[i]==used2[u]-1 && !fl){prev[i]=u;DFS(i);}
	  }
	  else
	  {
	    for(i=2;i<=1+k;i++)
	    if(G[u][i] && !used[i] && used2[i]==used2[u]-1 && !fl){prev[i]=u;DFS(i);}
	  }	  
}
void solve()
{
	int j,flow;
//	printf("solve\n");
	
    while(BFS())
    {
	  //printf("BFS solve\n");
	  //for(j=1;j<=2+k+n;j++)printf("%d ",used2[j]);
	  //printf("\n");	
	  //system("pause");
	  while(1)
	  {
		//printf("DFS solve\n");
	    fl=0;
		DFS(1);
		//for(j=1;j<=2+k+n;j++)printf(" %d %d   | ",used[j],prev[j]);
	    //printf("\n");
	    
	    //system("pause");
	    if(fl==0)break;
	    
	    
	    j=2+k+n;
	    flow=MAX;
	    while(j!=1)
	    {
		  flow=min(flow,G[prev[j]][j]);
		  j=prev[j];
		}
		
		ans+=flow;
	    j=2+k+n;
	    while(j!=1)
	    {
		  G[prev[j]][j]-=flow;
		  G[j][prev[j]]+=flow;
		  j=prev[j];
		}
	  }
	  memset(used,0,sizeof(used));
	  memset(used2,0,sizeof(used2));
	}
}    
int main()
{
	int i,j,sum=0,bi,ci;
	
	scanf("%d%d",&n,&k);
	for(i=0;i<n;i++)
	{
	 scanf("%d",&j);
	 sum+=j;
	 G[2+k+i][2+k+n]=j;
	}
	for(j=0;j<k;j++)
	{
	 scanf("%d%d",&bi,&ci);
	 G[1][2+j]=bi;
	 for(i=0;i<ci;i++)
	 {
	  scanf("%d",&bi);
	  G[2+j][1+k+bi]=MAX;
	 }
	}
	
	//printf("%d %d %d\n",G[1][2],G[1][3],G[1][4]);
	solve();
	if(ans==sum)printf("Yes\n");
	else printf("No\n");
return 0;
}
